const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const cover_artworks = sequelize.define(
    'cover_artworks',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

prompt: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"generated",


"selected",


"archived"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  cover_artworks.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.cover_artworks.belongsTo(db.songs, {
      as: 'song',
      foreignKey: {
        name: 'songId',
      },
      constraints: false,
    });

    db.cover_artworks.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.cover_artworks.hasMany(db.file, {
      as: 'art_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.cover_artworks.getTableName(),
        belongsToColumn: 'art_images',
      },
    });


    db.cover_artworks.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.cover_artworks.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return cover_artworks;
};


